#pragma once
#include "Archiver.h"
namespace Themis {

/**
    UnLha32.dllpďɃt@C߂̃NXB
*/
class CUnLhaArchiver: public IArchiver {
public:
    CUnLhaArchiver();
    ~CUnLhaArchiver();

    void ConfigDialog(HWND hWnd);

private:
    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual EType InnerGetType() const { return eTypeLoadable; }
};

typedef DefaultFactory<CUnLhaArchiver, IArchiver>  CUnLhaArchiverFactory;

}
