#pragma once
#include "MsgHook.h"
namespace Themis {

/**
    ̌`Rɕςo郊[W̃bp[B
*/
class CRegion : private boost::noncopyable {
public:
    CRegion() : m_hRgn(NULL) {}
    ~CRegion() { Delete(); }
    CRegion(const CRegion& r);

    /// 摜cb烊[W쐬(x͉䖝c)
    void Create(HDC hDC, const CRect& rc, COLORREF rgbTrans);
    /// p`̃[W쐬(S惂[h)
    void Create(CPoint pt[], int ptNum);
    /// p`̃[W쐬(݃[h)
    void CreateAlternate(CPoint pt[], int ptNum);
    /// `[W̍쐬
    void CreateStar(const CPoint& rCenter, int r);
    /// ~`̃[W쐬
    void CreateCircle(const CPoint& ptCenter, int pr);
    /// ȉ~`̃[W쐬
    void CreateEllipse(const CRect& rc);
    /// [W̍폜
    void Delete();

    /// [_aō
    CRegion& operator+=(const CRegion& oSrc);
    /// [̗̈Z
    CRegion& operator-=(const CRegion& oSrc);
    /// [Rs[
    CRegion& operator=(const CRegion& oSrc);

    /// region𑋂ɐݒ
    void SetToWindow(HWND hWnd);

private:
    HRGN    m_hRgn;

};

//////////////////////////////////////////////////////////////////////

/**
    EBhEɃ[Wݒ肷ׂ̃IuWFNg

    fXNgbv}XRbgƂpB

    Ă鎖́ARXgN^ CRegion::SetToWindow() ĂяoƁA
    EBhENbNꂽƂ PreDrag֐R[obNāA
    ꂪtrueԂ̓^Cgo[hbOƂɂđ悤ɂ鎖B
*/
class CRegionHooker: private IMsgHooker {
public:
    class IOwner {
    public:
        virtual bool IsDraggable(const CPoint& pt) = 0;
    };
    class CNoDrag: public IOwner {
        bool IsDraggable(const CPoint& pt) { return false; }
    };
    class CDragAlways: public IOwner {
        bool IsDraggable(const CPoint& pt) { return true; }
    };

    CRegionHooker(CRegion& rRegion, HWND hWnd, CMsgHook& rMsgHook, const std::tr1::shared_ptr<IOwner>& pOwner);
    ~CRegionHooker();

private:
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    std::tr1::shared_ptr<IOwner>   m_pOwner;
};

}
