#pragma once
#include "MsgHook.h"
namespace Themis {

class CWindow;

/**
    _CAO̊eRg[Ƀc[`bvt邽߂̃NXB
*/
class CDialogTooltip : private IMsgHooker {
public:
    CDialogTooltip(CWindow& rWindow);
    CDialogTooltip(HWND hWnd, CMsgHook& rMsgHook);

    void Add(int nId, const string& msg);
    void Remove(int nId);

    /// InitialDelay, AutoPopDelay, ReshowDelayݒ
    void SetAutomaticDelay(int n);
    /// `bvŏɕ\܂ł̎Ԃݒ
    void SetInitialDelay(int n);
    /// ړƂ̂\܂ł̎Ԃݒ
    void SetReshowDelay(int n);
    /// `bv\Ă鎞Ԃݒ
    void SetAutoPopDelay(int n);

private:
    ~CDialogTooltip();
    void Initialize(HWND hWnd, CMsgHook& rMsgHook);

    void InnerAdd(int nId, char* pszMsg);

    bool HookMsg(CMsgHookPrms& rPrms);
    BOOL PostMsg(UINT u, WPARAM w, LPARAM l) { return ::PostMessage(m_hToolTip, u, w, l); }
    LRESULT SendMsg(UINT u, WPARAM w, LPARAM l) { return ::SendMessage(m_hToolTip, u, w, l); }

private:
    HWND m_hWnd;
    HWND m_hToolTip;
    boost::ptr_deque<std::string> msgs;
};

}
